program FeatureParser;

{$APPTYPE CONSOLE}

{$R *.res}

{$R 'DelphiSpecI18n.res' '..\DelphiSpec\Source\DelphiSpecI18n.rc'}

uses
  System.SysUtils,
  System.IOUtils,
  uFeatureParser in 'uFeatureParser.pas',
  DelphiSpec.Assert in '..\DelphiSpec\Source\DelphiSpec.Assert.pas',
  DelphiSpec.Attributes in '..\DelphiSpec\Source\DelphiSpec.Attributes.pas',
  DelphiSpec.Core in '..\DelphiSpec\Source\DelphiSpec.Core.pas',
  DelphiSpec.DataTable in '..\DelphiSpec\Source\DelphiSpec.DataTable.pas',
  DelphiSpec.DUnit in '..\DelphiSpec\Source\DelphiSpec.DUnit.pas',
  DelphiSpec.DUnitX in '..\DelphiSpec\Source\DelphiSpec.DUnitX.pas',
  DelphiSpec.Parser in '..\DelphiSpec\Source\DelphiSpec.Parser.pas',
  DelphiSpec.Scenario in '..\DelphiSpec\Source\DelphiSpec.Scenario.pas',
  DelphiSpec.StepDefinitions in '..\DelphiSpec\Source\DelphiSpec.StepDefinitions.pas';

var
  FileName: string;
  Parser: TFeatureParser;
begin
  Parser := TFeatureParser.Create;
  try
    try
      Writeln('Generating Pascal source files from feature file...');

      for FileName in  TDirectory.GetFiles(GetCurrentDir, '*.feature', TSearchOption.soAllDirectories) do
      begin
        Write(Format('Processing %s...', [FileName]));
        Parser.Parse(FileName);
        Writeln('done');
      end;
      Readln;
    except
      on E: Exception do
        Writeln(E.ClassName, ': ', E.Message);
    end;
  finally
    Parser.Free;
  end;
end.
